/**
  ******************************************************************************
  * @file           : T1.h
  * @date           : 16.11.2022
  * @author:        : Stanislav Novak
  * @brief          : File incluedes functions for handeling Timer1 
  * 
  * The file is part of Ard-eLabViewer
  * 
  * 
**/
#define CHPWM 2
unsigned char pwmRun = 0;
unsigned char clockBits;
unsigned int pwmPeriod;
unsigned int pwmDC;
void inline setPWMDuty(unsigned int duty){
      unsigned long dutyCycle = pwmPeriod;
      dutyCycle *= duty;
      dutyCycle >>= 10;
      OCR1A = dutyCycle;
    }
    
void t1Period(unsigned long microseconds){//TODO edit
      unsigned char clockShift;
      unsigned long cycles = microseconds;
      
      if (cycles < (1UL<<16)) {//usual 130 Hz+
        clockBits = _BV(CS10);
        clockShift=0;
      } else if (cycles < (1UL<<19)) {
        clockBits = _BV(CS11);
        clockShift = 3;
      } else if (cycles < (1UL<<22)) {
        clockBits = _BV(CS11) | _BV(CS10);
        clockShift = 6;
      } else if (cycles < (1UL<<24)) { //less than sec
        clockBits = _BV(CS12);
        clockShift = 8;
      } else if (cycles < (1UL<<26)) {
        clockBits = _BV(CS12) | _BV(CS10);
        clockShift = 10;
      } else {
        clockBits = _BV(CS12) | _BV(CS10);
        clockShift = 10;
        cycles = -1UL;
      }
      
      pwmPeriod = (unsigned int)(cycles >> clockShift);
      ICR1 = pwmPeriod;
      TCNT1 = 0; //start from zero
      TCCR1B = _BV(WGM13) | clockBits;
}


void inline sendTimerVal() {
  Serial.write(0xFE);
  Serial.write(0x0); Serial.write(0x12); Serial.write(0x7A); Serial.write(0);
  Serial.write('F'); Serial.write(CHPWM);
  unsigned long t1val = ICR1;
  switch (TCCR1B & 7) {
    case 5://TODO? really workin?
      t1val <<= 2;
    case 4:
      t1val <<= 2;
    case 3:
      t1val <<= 3;
    case 2:
      t1val <<= 3;
    default:
      break;
  }
  Serial.write(0xFE);
  Serial.write((char)(t1val & 0xff)); Serial.write((char)((t1val & 0xff00) >> 8)); Serial.write((char)((t1val & 0xff0000) >> 16)); Serial.write((char)((t1val & 0xff000000) >> 24));
  Serial.write('D'); Serial.write(CHPWM);
}

void changefreq(unsigned long freq) {
  TCCR1A &= ~_BV(COM1A1);
  if (!(freq & (0x3 << 14))) { //from DataConverter.cpp in pc app
    t1Period(8000000 / freq);
  }
  else if (freq & (0x1 << 14)) {
    t1Period(8000 / (freq & 0x3FFF));
  }
  else if (freq & (0x2 << 14)) {
    t1Period(8 / (freq & 0x3FFF));
  }
  sendTimerVal();
  setPWMDuty(pwmDC);
  if (pwmRun) TCCR1A |= _BV(COM1A1);
  else TCCR1A &= ~_BV(COM1A1);
}
